"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const completions_1 = require("@heroku-cli/command/lib/completions");
const cli_ux_1 = require("cli-ux");
const fs = require("fs-extra");
const path = require("path");
const create_1 = require("../commands/autocomplete/create");
exports.completions = async function ({ type, app }) {
    const logInOut = type === 'login' || type === 'logout';
    const cachePath = path.join(this.config.cacheDir, 'autocomplete', 'completions');
    const rm = () => fs.emptyDir(cachePath);
    const rmKey = (cacheKey) => fs.remove(path.join(cachePath, cacheKey));
    if (type === 'app')
        return rmKey('app');
    if (type === 'addon' && app)
        return rmKey(`${app}_addons`);
    if (type === 'config' && app)
        return rmKey(`${app}_config_vars`);
    if (logInOut)
        return rm();
    cli_ux_1.default.action.start('Updating completions');
    await rm();
    const config = this.config;
    await create_1.default.run([], config);
    await completions_1.AppCompletion.options({ config });
    await completions_1.PipelineCompletion.options({ config });
    await completions_1.SpaceCompletion.options({ config });
    await completions_1.TeamCompletion.options({ config });
    cli_ux_1.default.done();
};
